module WipApi
  class Todo
    def initialize(client = Client.new)
      @client = client
    end

    def create(attributes = {})
      query = %{
      mutation createTodo {
        createTodo(input: {#{serialize_attributes(attributes)}}) {
          id
          body
          completed_at
        }
      }
    }
      json = @client.make_request(query)
      json["data"]["createTodo"]
    end

    def complete(todo_id)
      query = %{
      mutation completeTodo {
        completeTodo(id: #{todo_id}) {
          id
          body
          completed_at
        }
      }
    }
      json = @client.make_request(query)
      json["data"]["completeTodo"]
    end

    private

    def serialize_attributes(attributes)
      attributes.collect do |k,v|
        "#{k}: \"#{v}\""
      end.join(", ")
    end
  end
end
